#ifndef __i386_H
#define __i386_H

static __inline__ void port_outb(int value,int port)
{
  __asm__ volatile ("outb %0,%1"
                    ::"a"((unsigned char)value),"d"((unsigned short)port));
}

static __inline__ void port_outw(int value,int port)
{
  __asm__ volatile ("outw %0,%1"
                    ::"a"((unsigned short)value),"d"((unsigned short)port));
}

static __inline__ void port_outl(int value,int port)
{
  __asm__ volatile ("outl %0,%1"
                    ::"a"((unsigned long)value),"d"((unsigned short)port));
}

static __inline__ int port_inb(int port)
{
  unsigned char value;
  __asm__ volatile ("inb %1,%0"
                   :"=a" (value)
                   :"d" ((unsigned short)port));
  return value;
}

static __inline__ int port_inw(int port)
{
  unsigned short value;
  __asm__ volatile ("inw %1,%0"
                   :"=a" (value)
                   :"d" ((unsigned short)port));
  return value;
}

static __inline__ int port_inl(int port)
{
  unsigned int value;
  __asm__ volatile ("inl %1,%0"
                   :"=a" (value)
                   :"d" ((unsigned short)port));
  return value;
}

#define inpb  port_inb
#define inpw  port_inw
#define inpl  port_inl
#define outpb port_outb
#define outpw port_outw
#define outpl port_outl

#define GRA_I 0x3CE
#define GRA_D 0x3CF

#endif

